//+------------------------------------------------------------------+
//|                                                                  |
//|                                                                  |
//|    DMBSYS : use on EUR/GBP - EUR/USD - EUR/CHF  [TF M5] 25.10.07 |
//+------------------------------------------------------------------+ :p
 
extern bool    MM        = true; // razmer lota avtomatitchecki chtitaetca
extern int     Risk      = 10;    // v procentax (%). minimum '1' maximum '100' 
extern double  ManLot    = 0.1;   // razmer lota ecli 'MM=false'
extern int     Shift     = 3; 
extern int     Limit     = 18;
extern int     TP        = 2;
extern int     Slippage  = 3;
/*--------TradingTime--------*/
extern int            OpenHour  = 20;  //19
extern int            CloseHour = 8;   //7
/*--------WeekEndStop--------*/
extern int            WED1      = 5;    //5 Day of begin (sunday)
extern int            WEH1      = 23;   //22 Hour of begin
extern int            WED2      = 1;    //1 Day of end (monday)
extern int            WEH2      = 3;    //2 hour of end
//----------------------------------------------------------------------------
extern int     MAGIC = 12356;
//----------------------------------------------------------------------------
bool           first     = true; 
double         MaxLot    = 100;
double         MinLot    = 0.1;
int            LotsDigit = 1;
double TV,SP;
//---------------------------------------------------------------------------- 
int TradingTime,WE; double a, b; 
 
int start()
   { 
   if (WEstop() == 0 && Tradetime() == 1)
      {
      if (first) 
         {
         a=Ask; 
         b=Bid; 
         first=false; 
         return(0);
         }
       
      if (Ask-a>=Shift*Point) 
         {
         OrderSend(Symbol(),OP_SELL,GetLots(),Bid,Slippage,0,0,"Lucky",MAGIC,0,Red);
         }  
      if (b-Bid>=Shift*Point) 
         {
         OrderSend(Symbol(),OP_BUY,GetLots(),Ask,Slippage,0,0,"Lucky",MAGIC,0,Blue);
         } 
      }
   a=Ask;  
   b=Bid; 
  
   CloseAll(); 
   return(0);
   } 
//----------------------------------------------------------------------------- 
void CloseAll() 
   { 
   for (int cnt = OrdersTotal()-1 ; cnt >= 0; cnt--) 
      { 
      OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES); 
      if (OrderSymbol() == Symbol() && OrderMagicNumber()==MAGIC) 
         { 
         if (SecurProfit()==1 || Tradetime() == 0)
            { 
            if(OrderType()==OP_BUY)  OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Yellow); 
            if(OrderType()==OP_SELL) OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Yellow); 
            } 
         else 
            { 
            if((OrderType()==OP_BUY)  && (((OrderOpenPrice()-Ask)/Point) > Limit)) 
            OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Aqua); 
            if((OrderType()==OP_SELL) && (((Bid-OrderOpenPrice())/Point) > Limit)) 
            OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Aqua); 
            } 
         } 
      } 
   } 
//--------------------------------------------------------------------------
int WEstop()
   {
   WE=0;
   if (TimeHour(TimeCurrent()) > WEH1 && DayOfWeek() == WED1) WE=1;
   if (TimeHour(TimeCurrent()) < WEH2 && DayOfWeek() == WED2) WE=2;
   return(WE);
   }
//-------------------------------------------------------------------------- 
int Tradetime()
   {
   TradingTime=0;
   if (TimeHour(TimeCurrent()) >= OpenHour || TimeHour(TimeCurrent())< CloseHour)   TradingTime=1;
   return(TradingTime); 
   }
//-------------------------------------------------------------------------- 
double GetLots() 
   {
   double lots,MD,RM,FMM,MinLot,MaxLot; int lotsdigit;
   MD = NormalizeDouble(MarketInfo(Symbol(), MODE_LOTSTEP), 2); // chag mejdu lotami (0.1 ili 0.01)pomojit nam uznat ecli eto micro accunt ili net
   RM = NormalizeDouble(MarketInfo(Symbol(), MODE_MARGINREQUIRED), 4);
   FMM = (RM+5)*100;
   if (MD==0.01) lotsdigit=2;
   else lotsdigit=1;
   LotsDigit=lotsdigit;
   if (MM==true) lots = NormalizeDouble(AccountFreeMargin()/(FMM/Risk)-0.05,LotsDigit);
   else lots=ManLot;
   MinLot=NormalizeDouble(MarketInfo(Symbol(),MODE_MINLOT),2);    // minimalnaia pozvolena stavka
   MaxLot=NormalizeDouble(MarketInfo(Symbol(), MODE_MAXLOT),2);   // maximalnaia pozvolena stavka
   if (LotsDigit == 2) MinLot = 0.01; 
   if (lots < MinLot) lots = MinLot;  
   if (lots > MaxLot) lots = MaxLot;     
   return (lots);      
   }
//-------------------------------------------------------------------------
double TickValue() // 
   {
   double tv;
   tv = NormalizeDouble(MarketInfo(Symbol(), MODE_TICKVALUE), 4); // pribl za 1 pip c 1 lot
   return(tv);
   }
int SecurProfit()
   {
   int sp=0;
   if (OrderProfit()>(TickValue()*GetLots()*TP)) sp=1; // ecli pribilnix ticksov viche 'TP'. rezultat 'SecurProfit()' budit '1'
   return(sp);
   }
   
   
   
   
   
   
   